package com.fp.persistence.pgeneral.score;

import java.sql.Timestamp;
import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import com.fp.dto.hb.History;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENESCOREADJUSTMENT*/
@Embeddable
public class TgeneScoreAdjustmentKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId,History{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="DATETO", nullable=false,updatable=false)

/**
* Fecha hasta la cual esta vigente el registro con datos de la cuenta.
*/
private Timestamp dateto;

@Column(name="SCOREDATE", nullable=false,updatable=false)

/**
* Fecha de calificacion 
*/
private Timestamp scoredate;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania
*/
private Integer companycode;

@Column(name="ACCOUNT", nullable=false,updatable=false)

/**
* Numero de cuenta
*/
private String account;

/**Contructor por defecto*/
public TgeneScoreAdjustmentKey(){}
/**Contructor de TgeneScoreAdjustmentKey
@param pDateto Fecha hasta la cual esta vigente el registro con datos de la cuenta.
@param pScoredate Fecha de calificacion 
@param pCompanycode Codigo de compania
@param pAccount Numero de cuenta
*/
public TgeneScoreAdjustmentKey(Timestamp pDateto,Timestamp pScoredate,Integer pCompanycode,String pAccount){
 dateto=pDateto;
 scoredate=pScoredate;
 companycode=pCompanycode;
 account=pAccount;
}
/**Obtiene el valor de dateto
@return valor de dateto*/
public Timestamp getDateto(){
  return dateto;
}
/**Fija el valor de dateto
@param pDateto nuevo Valor de dateto*/
public void setDateto(Timestamp pDateto){
  dateto=pDateto;
}

/**Obtiene el valor de scoredate
@return valor de scoredate*/
public Timestamp getScoredate(){
  return scoredate;
}
/**Fija el valor de scoredate
@param pScoredate nuevo Valor de scoredate*/
public void setScoredate(Timestamp pScoredate){
  scoredate=pScoredate;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Obtiene el valor de account
@return valor de account*/
public String getAccount(){
  return account;
}
/**Fija el valor de account
@param pAccount nuevo Valor de account*/
public void setAccount(String pAccount){
  account=pAccount;
}

/**Implementacion de la comparacion de TgeneScoreAdjustmentKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneScoreAdjustmentKey))return false;
  TgeneScoreAdjustmentKey that = (TgeneScoreAdjustmentKey) o;
  if (this.getDateto() == null || that.getDateto() == null){
      return false;
  }
  if (! this.getDateto().equals(that.getDateto())){
    return false;
  }
  if (this.getScoredate() == null || that.getScoredate() == null){
      return false;
  }
  if (! this.getScoredate().equals(that.getScoredate())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  if (this.getAccount() == null || that.getAccount() == null){
      return false;
  }
  if (! this.getAccount().equals(that.getAccount())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TgeneScoreAdjustmentKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getDateto() == null ? 0 : this.getDateto().hashCode());
    result = result * 37 + (this.getScoredate() == null ? 0 : this.getScoredate().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    result = result * 37 + (this.getAccount() == null ? 0 : this.getAccount().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
public Object getId() {
  return null;
}
}
